package j3d.cr325;

import javax.media.j3d.*;
import javax.vecmath.Vector3f;

/**
 * DocJava, Inc.
 * http://www.docjava.com
 * Programmer: dlyon
 * Date: Mar 30, 2004
 * Time: 3:26:29 PM
 */
public class BasicUniverse {
    VirtualUniverse universe;
    Locale locale ;
    BranchGroup viewPlatformRoot;
    TransformGroup viewPlatformTransform;
    ViewPlatform viewPlatform;
    View view;
    Canvas3D canvas;
    float zViewDistance;
    public BasicUniverse(Canvas3D extCanvas, float zViewDist){
        canvas = extCanvas;
        zViewDistance = zViewDist;
        universe = new VirtualUniverse();
        locale = new Locale(universe);
        viewPlatformRoot = new BranchGroup();
        viewPlatformTransform = new TransformGroup();
        setupViewPlatform();
        viewPlatformRoot.addChild(viewPlatformTransform);
        setupView(extCanvas);
        view.attachViewPlatform(viewPlatform);
        locale.addBranchGraph(viewPlatformRoot);
    }
    private void setupView(Canvas3D c){
        view = new View();
        view.addCanvas3D(c);
        view.setPhysicalBody(new PhysicalBody());
        view.setPhysicalEnvironment(new PhysicalEnvironment());
    }
    private void setupViewPlatform(){
        viewPlatform = new ViewPlatform();
        setViewingDistance(zViewDistance);
        viewPlatformTransform.addChild(viewPlatform);

    }
    public void setViewingDistance(float viewDistance){
        zViewDistance = viewDistance;
        Transform3D transform = new Transform3D();
        transform.set(new Vector3f(0,0,zViewDistance));
        viewPlatformTransform.setTransform(transform);
    }
    public void addBranchGraph(BranchGroup bg){
        locale.addBranchGraph(bg);
    }
    public TransformGroup getViewPlatformTransform(){
        return viewPlatformTransform;
    }
    public View getView() {
        return view;
    }

}
